<template>
   <nav class="navbar navbar-expand-lg navbar-light border-bottom">
        <div class="container-fluid d-flex justify-content-between">
            <ul class="navbar-nav me-auto mb-2 mb-lg-0  space">
                <tool-list
                    v-for="(item, index) in toolBar"
                    :key="index"
                    :item="item" 
                    @click="checkAction(item.action)"
                />
            </ul>    
        </div>
    </nav>
    <div class="table-responsive">
        <table class="table">
            <thead>
                <tr class="text-light bg-primary border-0 text-center">
                    <th class="px-1 mx-1" style="width:3%;"></th>
                    <th-element
                        v-for="(item, index) in inputItems"
                        :key="index"
                        :item="item"
                        @click="(inVisible = !inVisible)"
                    />
                </tr>
            </thead>

            <tbody >
                <input-table
                @cleanInput="clearInputValue"
                :items="inputItems" v-if="inVisible" 
                />
                <list-data-table 
                    v-for="(item, index) in searchElement"
                    :key="index" 
                    :item="item" 
                    :inputItems="inputItems"
                    :contextItem="contextItem"
                    @editDblclic="editDblclic" 
                    @IS_CHECKED="isChecked"
                />
            </tbody>
        </table>
    </div>
    <router-view></router-view>
       <footer-pages 
        :pageNumber="pageNumber" 
        :limitPage="limitPage" 
        :count="count"
        @nextPage="nextPage" 
        @prevPage="prevPage"
    />
</template>


<script>
import ListDataTable from '@/components/UI/ListDataTable.vue';
import {ref, onMounted, computed, watchEffect} from 'vue';
import { useStore } from 'vuex';
import {useRouter, useRoute } from 'vue-router';
import {mapActions, mapGetters, mapMutations} from 'vuex';
import ThElement from '@/components/UI/ThElement.vue';

export default {
    components: { ListDataTable, ThElement },
    setup(_, {emit}){
        const store = useStore();
        const router = useRouter();
        const route = useRoute();
        const inVisible = ref(false);
        const pageNumber = ref(0);
        const limitPage = ref(3);
        
        const contextItem = ref([
            {name:'date_create', desc:'Скопировать дату создания', action: 'copyElem'},
            {name:'client', desc:'Скопировать клиента', action: 'copyElem'},
            {name:'date_repeat', desc:'Скопировать дату повтора', action: 'copyElem'},
            {name:'date_execution', desc:'Скопировать дату выполнения', action: 'copyElem'},

        ]);

        onMounted(()=> {store.dispatch('GET_CONTRACTS_LIST_ITEMS_FROM_API');});

        const listItems = computed(() => store.getters.CONTRACTS_LIST_ITEMS);

        const inputItems = computed(() => store.getters.CONTRACT_INPUT_ITEMS);

        const count = computed(() => store.getters.CONTRACTS_LIST_ITEMS_COUNT)

        const toolBar = computed(() => store.getters.CONTRACTS_TOOL_BAR);
        
        function updateListItems(data){store.commit('SET_CONTRACTS_LIST_ITEM_TO_STATE', data)};
        
        const searchElement = computed(() => {
        
        let name = '';
        let value = '';

        inputItems.value.forEach(el => {
            if(el.value){
                name = el.name;
                value = el.value;
            }
        });
        
        if(!inputItems.value.some(elem => elem[name])){
            return paginatedData();
        } else {
            return paginatedData().filter(item => item[name].toLowerCase().includes(value.toLowerCase()));
        }
    
    });

    watchEffect(() => checkInVisible());

    function checkInVisible(){
        if(!inVisible.value){
            clearInputValue();  
        }
    } 

    function checkAction(action){
        inVisible.value = false;
        switch (action) {
            case 'delete':
                deleteItemById();
                break;
            case 'edit':
                edit();
                break;
        }
    }

    function nextPage(){
        pageNumber.value++;
    }

    function prevPage(){
        pageNumber.value--;
    }
    
    function paginatedData(){
        let start = pageNumber.value * limitPage.value,
        end = start + limitPage.value;
        return listItems.value.slice(start, end); 
    }

    function clearInputValue(){
    inputItems.value.forEach(el => el.value = '');
    }

    function editDblclic(id){
        inVisible.value = false;
        router.push('/contracts/edit/' + id)
    }

    function isChecked(id){
            
        store.commit('IS_CHECKED_CHANGE_CONTRACTS_LIST_ITEM_TO_STAGE', id)
    }

    function edit(){
        const count =  listItems.value.filter(item => item.isChecked === true).length
        if(count === 1) {
                const id = listItems.value.find(el => el.isChecked === true).id
                router.push('/contracts/editContract/' + id)
        }else if(count > 1){
                alert('Выберите только один элемент!')
        }else {
                alert('Выберите хотя бы один элемент!')
        }
    }

    function deleteItemById(){
        if(listItems.value.filter(item => item.isChecked === true).length < 1){
            alert('Элементы для удаления не выбраны!')
        }else{
            if(confirm('Вы действительно хотите удалить выбранные Вами элементы ?')){
                listItems.value.forEach(el => {
                    if(el.isChecked){
                        updateListItems(listItems.value.filter(p => p.id !== el.id)); 
                    }
                });
            }
        }    
    }

        return {
            toolBar,
            inputItems,
            inVisible,
            pageNumber,
            searchElement,
            count,
            contextItem,
            pageNumber,
            limitPage,
            isChecked,
            checkAction,
            nextPage,
            prevPage,
            clearInputValue,
            editDblclic
        }
    }
}
</script>
